const WebSocket = require('ws');
const wsServer = new WebSocket.Server({ noServer: true });

const { safeSend } = require('../common/util');

const URL_PREFIX = '/main/';

wsServer.on('connection', function connection(ws, param) {
  if(!param.user){
    // param.mainUser.setWs(ws);
    safeSend(ws, JSON.stringify({
      code: 0,
      data: param.mainUser.getUsers()
    }));
  }
});



function handleUpgrade(req, socket, head) {

  const username = req.url.substr(URL_PREFIX.length);
  const mainUser = req.mainUser;

  const param = Object.create(null);

  if(username){
    const user = mainUser.getUser(username);
    if(!user){
      socket.destroy();
      return;
    } else {
      param.user = user;
    }
  }

  
  param.mainUser = mainUser;
  

  wsServer.handleUpgrade(req, socket, head, function done(ws) {
    wsServer.emit('connection', ws, param);
  });
}

module.exports = {
  URL_PREFIX,
  handleUpgrade
}